<template>
  <div v-if="nextEvent">
    <p>
      <b>{{ nextEvent.summary }}</b>
      <br/>
      <small>{{ nextEvent.calendar }}</small>
    </p>

    <p>
      <span class="flex--between">
        <time>{{ formatDate(nextEvent.dtstart) }}</time>
        <time v-if="!nextEvent.all_day"
        >&nbsp;{{ formatTime(nextEvent.dtstart) }} -
          {{ formatTime(nextEvent.dtend) }}</time
        >
      </span>
      <small class="cne__margin--top">{{ nextEvent.location }}</small>
    </p>
    <p>{{ nextEvent.description }}</p>
  </div>
  <p v-else>{{ t("no_event_msg") }}</p>
</template>

<script>
module.exports = {
  name: "calendar-upcoming-event",
  props: {
    currentSettings: {
      type: Object,
      required: true
    },
    currentStyles: {
      type: Object,
      required: true
    },
    currentDimensions: {
      type: Object,
      required: true
    },
    records: {
      type: Array,
      required: false
    },
    language: {
      type: String,
      required: true
    },
    locale: {
      type: String,
      required: true
    },
    backendUrl: {
      type: String,
      required: true
    },
    fetchAsset: {
      type: Function,
      required: false
    }
  },
  timeFormatter: new Intl.DateTimeFormat(this.language, {
    ...this.options,
    hour: "2-digit",
    minute: "2-digit"
  }),
  data: function () {
    return {
      options: {
        hour: "2-digit",
        minute: "2-digit"
      }
    };
  },
  computed: {
    titleFilterLowerCased() {
      return this.currentSettings.titleFilter.toLowerCase();
    },
    nextEvent: function () {
      const nextEvents = this.records.reduce(this.recordsReducer, []);

      // Cache comparison date for this run.
      const dateUpperBoundary = Date.now() + this.currentSettings.dateFilter * 86400000;
      return nextEvents
          .filter(event => event.dtstart.getTime() <= dateUpperBoundary)
          .sort((a, b) => a.dtstart - b.dtstart)
          .shift()
    },
  },
  methods: {
    /**
     * Reduces the records array to an array of upcoming events, matching the title filter if set.
     * NOTE: Assumes that the backend sorts calendar's event by dtstart, i.e. the first event is the upcoming one.
     * @param {array} acc The accumulator for this reducer function.
     * @param {Object} record The GroupSchemas::CalendarResource record to be reduced.
     * @returns {array} All events that match the title filter or occur next in the calendar.
     */
    recordsReducer: function (acc, record) {
      if (record.attributes.events.length === 0) return acc;

      if (this.currentSettings.titleFilter.length > 0) {
        // Use `find` instead of `filter` to stop after the first match.
        const firstMatch = record.attributes.events.find(event => {
          return event.summary.toLowerCase().includes(this.titleFilterLowerCased)
        });
        // firstMatch might be undefined, do not push that as an event.
        if (firstMatch) acc.push(this.prepareEventForSorting(record, firstMatch));
      } else {
        acc.push(this.prepareEventForSorting(record, record.attributes.events[0]));
      }
      return acc;
    },
    /**
     * Puts calendar metadata (name and description) on an event, and replaces the ISO8601 date
     * string with a date object for easier comparison + formatting..
     * @param {Object} calendar The calendar record which contains the event.
     * @param {Object} event The event to map.
     */
    prepareEventForSorting: function (calendar, event) {
      return {
        ...event,
        calendar: calendar.attributes.name,
        calendarDescription: calendar.attributes.description,
        dtstart: new Date(event.dtstart),
        dtend: new Date(event.dtend)
      }
    },
    /**
     * Test if two given dates are the same.
     * @param {Date} a The first date to compare.
     * @param {Date} b The second date to compare.
     */
    sameDate: function (a, b) {
      return (
          a.getFullYear() === b.getFullYear() &&
          a.getMonth() === b.getMonth() &&
          a.getDay() === b.getDay()
      );
    },
    /**
     * Formats a date including its weekday according to the current locale.
     * If the date is today or tomorrow, the weekday is replaced with `today`/ `tomorrow.
     * @param {Date} date The date to format.
     * @returns {string} The formatted date.
     */
    formatDate: function (date) {
      const now = new Date();

      if (this.sameDate(date, now)) {
        return `${this.$translate.text("cue_today_message")}, ${new Intl.DateTimeFormat(
            this.language
        ).format(date)}`;
      }
      if (this.sameDate(date, new Date(now.getTime() + 86400000))) {
        return `${this.$translate.text("cue_tomorrow_message")}, ${new Intl.DateTimeFormat(
            this.language
        ).format(date)}`;
      }

      return new Intl.DateTimeFormat(this.language, {
        weekday: "long",
        day: "numeric",
        month: "numeric",
        year: "numeric"
      }).format(date);
    },
    /**
     * Formats the time of a given Date according to the current locale.
     * @param date The datetime to format.
     * @returns {string} The formatted time string.
     */
    formatTime: function (date) {
      return this.$options.timeFormatter.format(date);
    }
  },
  locales: {
    enGb: {
      no_event_msg: "No upcoming event! Enjoy 😊",
      cue_today_message: "today",
    },
    deDe: {
      no_event_msg: "Kein bevorstehender Termin! Alles gut 😊",
      cue_today_message: "heute",
    },
    frFr: {
      no_event_msg: "Pas de date à venir! Tout va bien 😊",
      cue_today_message: "aujourd'hui",
    },
    esEs: {
      no_event_msg: "¡No hay una fecha próxima! Todo está bien. 😊",
      cue_today_message: "hoy",
    },
    plPl: {
      no_event_msg: "Nie najbliższy termin! Wszystko jest dobrze 😊",
      cue_today_message: "dzisiaj",
    },
    koKr: {
      no_event_msg: "예정된 약속이 없습니다! 다 괜찮아 😊",
      cue_today_message: "오늘",
    }
  },
};
</script>
<style>
.cne__margin--top {
  display: block;
  margin-top: 0.625rem;
}
</style>
